SystemOrganization addCategory: #'DAO-Satellite'!

Object subclass: #Command
	instanceVariableNames: 'receiver id parameters responseParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Command class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/15/2013 20:28'!
newWithReceiver: aReceiver andId: anId
	^ self new initializeWithReceiver: aReceiver andId: anId ! !

!Command class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/16/2013 10:00'!
newWithReceiver: aReceiver andId: anId andParameterSizes: aList
	^ self new initializeWithReceiver: aReceiver andId: anId andParameterSizes: aList! !

!Command methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 13:03'!
addParameterValue: aValue
	| parameter |
	
	parameter := parameters at: (parameters findFirst: [ :p | (p value) isNil]).
	
	parameter value: aValue.
! !

!Command methodsFor: 'deserialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 19:54'!
deserialize: serializedResponse 

	| responseData readStream |

	responseParameters isEmpty ifTrue: [ ^VoidCommandResponse new. ].
		
	"discard first 3 bytes of sequence number"
	readStream := ReadStream on: (serializedResponse allButFirst: 3).

	responseData := OrderedCollection new.

	responseParameters do: [ :parameter | responseData add: (parameter deserialize: readStream)].
	
	^ DataCommandResponse newWithData: responseData.
! !

!Command methodsFor: 'executing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 15:11'!
execute
	^ self subclassResponsibility.! !

!Command methodsFor: 'accessing' stamp: 'EzequielDavidovichCaballero 9/15/2013 17:46'!
id
	^ id! !

!Command methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:44'!
initialize
	self initializeCommandDefinition ! !

!Command methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:44'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.! !

!Command methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 12:48'!
initializeWithReceiver: aReceiver andId: anId

	receiver := aReceiver.
	id := anId.
	self initializeCommandDefinition.! !

!Command methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 18:25'!
receiver
	^ receiver! !

!Command methodsFor: 'serialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/28/2013 11:57'!
serialize
	
	| stream |
			
	stream := WriteStream on: ByteArray new.
		
	stream nextPut: (id asByte).

	parameters do: [ :parameter |
		stream nextPutAll: (parameter serialize).
	].
	
	^ stream contents.! !

Command subclass: #GetNameCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!GetNameCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 15:12'!
execute
	^ MessageCommandResponse newWithMessage: (receiver name)! !

!GetNameCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 19:45'!
initializeCommandDefinition
	parameters := OrderedCollection new.
		
	responseParameters := OrderedCollection new.
	responseParameters add: StringCommandParameter new.
! !

Command subclass: #MemoryReadAddressCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryReadAddressCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:08'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	parameters add: (UnsignedIntegerCommandParameter new: 32).
	
	responseParameters := OrderedCollection new.
	responseParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).
! !

Command subclass: #MemoryReadChunkedAddressCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryReadChunkedAddressCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:14'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	responseParameters := OrderedCollection new.! !

Command subclass: #MemoryReadLongAddressCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryReadLongAddressCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:14'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.

	responseParameters := OrderedCollection new.
	responseParameters add: (UnsignedIntegerCommandParameter new: 32).
	responseParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).
! !

Command subclass: #MemoryWriteAddressCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryWriteAddressCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:13'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := StringCommandParameter new: 8.
	parameters add: parameter.

	responseParameters := OrderedCollection new.! !

Command subclass: #PlatformSetModeCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PlatformSetModeCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:13'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 8.
	parameters add: parameter.

	responseParameters := OrderedCollection new.! !

Command subclass: #PowerStbSetSwitchesStateCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PowerStbSetSwitchesStateCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:13'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 24.
	parameters add: parameter.
	
	responseParameters := OrderedCollection new.! !

Command subclass: #ThermalSetMatrixKeyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ThermalSetMatrixKeyCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 12:57'!
execute
	receiver setMatrixKey: ((parameters at: 1) value).
	
	^ VoidCommandResponse new.
	! !

!ThermalSetMatrixKeyCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:13'!
initializeCommandDefinition
	| parameter |
	
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.


	responseParameters := OrderedCollection new.! !

Command subclass: #ThermalShortTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ThermalShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:23'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	
	responseParameters := OrderedCollection new.
	responseParameters add: (UnsignedIntegerCommandParameter new: 8).
! !

Command subclass: #ThermalTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ThermalTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:42'!
initialize
	self initializeCommandDefinition.
! !

!ThermalTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 15:15'!
initializeCommandDefinition 
	self initializeParametersDefinition.
	self initializeResponseParametersDefinition.
! !

!ThermalTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 15:15'!
initializeParametersDefinition 
	parameters := OrderedCollection new.
! !

!ThermalTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 15:16'!
initializeResponseParametersDefinition 
	| parameter |

	responseParameters := OrderedCollection new.

	parameter := SignedIntegerCommandParameter new: 16.
	responseParameters add: parameter.

	parameter := SignedIntegerCommandParameter new: 16.
	responseParameters add: parameter.
! !

Object subclass: #CommandParameter
	instanceVariableNames: 'value bitSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

CommandParameter subclass: #ArrayCommandParameter
	instanceVariableNames: 'type arrayLength elementSize elementType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ArrayCommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:08'!
newWithElementType: type andElementSize: elementSize andLength: arrayLength
	^ self new initializeWithElementType: type andElementSize: elementSize andArrayLength: arrayLength.
	! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:06'!
deserialize: aReadStream 
	| result responseParameter |
	
	result := OrderedCollection new.
	
	[aReadStream atEnd] whileFalse: [ 
		" create an object of type elementType (i.e. UnsignedIntegerCommandParameter) and size in bits elementSize"
		responseParameter := elementType new: elementSize.
		value := responseParameter deserialize: aReadStream.
		result add: value.
	 ].

	^ result.! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 17:51'!
elementSize
	^ elementSize! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:07'!
initializeWithElementType: theType andElementSize: theElementSize andArrayLength: theArrayLength
	elementType := theType.
	elementSize := theElementSize.
	arrayLength := theArrayLength.! !

!CommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:03'!
new: aSize
	^ self new initializeWithBitSize: aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:04'!
byteSize
	^ (bitSize / 8)! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:04'!
initializeWithBitSize: aSize
	bitSize := aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:22'!
value
	^ value! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:22'!
value: aValue
	value := aValue! !

CommandParameter subclass: #SignedIntegerCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:31'!
deserialize: aReadstream 
	| serializedValue sign result |
	
	"take first 2 bytes from the input, first byte is sign"

	sign := aReadstream next asInteger.
	
	serializedValue := aReadstream next.
	
	result := serializedValue asInteger.
	
	(sign = 1) ifTrue: [ result := result * -1].
	
	^ result.! !

CommandParameter subclass: #StringCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!StringCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 19:49'!
deserialize: aReadStream 

	^ aReadStream contents asString.
! !

!StringCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:24'!
serialize 

	| valueBytes valueSize headerSize header result stream |

	valueBytes := value asByteArray.
	valueSize := valueBytes size.

	headerSize := (self byteSize).	
	header := ByteArray new: headerSize.
	header replaceFrom: (headerSize - (valueSize asByteArray size) + 1) to: headerSize with: (valueSize asByteArray).
	
	result := ByteArray new: headerSize + valueSize.
	stream := WriteStream on: result.
	stream nextPutAll: header.
	stream nextPutAll: valueBytes.

	^ result.
! !

CommandParameter subclass: #UnsignedIntegerCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!UnsignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:02'!
deserialize: aReadstream 
	| serializedValue |
	
	serializedValue := aReadstream next: (self byteSize).
	
	^ serializedValue asInteger.
! !

!UnsignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:24'!
serialize

	| valueBytes start stop result |
	
	result := ByteArray new: (self byteSize).
	
	valueBytes := value asByteArray.
	start := (result size) - (valueBytes size) + 1.
	stop := (result size).
	result replaceFrom: start to: stop with: valueBytes.
	
	^ result.
! !

Object subclass: #CommandResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

CommandResponse subclass: #DataCommandResponse
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!DataCommandResponse class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:23'!
newWithData: data
	^ self new initializeWithData: data.! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:28'!
data
	^ data! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:24'!
initializeWithData: aData
	data := aData! !

CommandResponse subclass: #MessageCommandResponse
	instanceVariableNames: 'message sequenceNumber contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MessageCommandResponse class methodsFor: 'class initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:08'!
newWithMessage: aMessage 
	^ self new initializeWithMessage: aMessage.! !

!MessageCommandResponse class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/17/2013 18:10'!
newWithSequenceNumber: aSequenceNumber andContents: anOrderedCollection 

	^self new initializeWith: aSequenceNumber andContents: anOrderedCollection ! !

!MessageCommandResponse class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/16/2013 20:32'!
newWithSequenceNumber: aSequenceNumber andMessage: aMessage 
	^ self new initializeWith: aSequenceNumber and: aMessage! !

!MessageCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/10/2013 21:01'!
= anObject
	^ message = anObject message
! !

!MessageCommandResponse methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/17/2013 18:12'!
at: aSmallInteger

	^ contents at: aSmallInteger ! !

!MessageCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/10/2013 21:02'!
initialize
	message = ''
! !

!MessageCommandResponse methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/16/2013 20:33'!
initializeWith: aSequenceNumber and: aMessage 
	sequenceNumber := aSequenceNumber.
	message := aMessage.! !

!MessageCommandResponse methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/17/2013 18:11'!
initializeWith: aSequenceNumber andContents: anOrderedCollection 
		sequenceNumber := aSequenceNumber.
		contents := anOrderedCollection.! !

!MessageCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/10/2013 21:06'!
initializeWithMessage: aMessage 
	message := aMessage.! !

!MessageCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/10/2013 21:02'!
message
	^ message
! !

!MessageCommandResponse methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/16/2013 20:34'!
sequenceNumber

	^ sequenceNumber! !

CommandResponse subclass: #VoidCommandResponse
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/10/2013 20:58'!
= anotherResponse
	"TODO reemplazar con una sola instancia global de VoidCommandResponse"
	^ code = anotherResponse code ! !

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/10/2013 20:58'!
code
	^ code! !

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/10/2013 20:56'!
initialize
	code = -1
! !

Object subclass: #ControllerLog
	instanceVariableNames: 'entries archive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ControllerLog class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:13'!
newWithArchive: aLogArchive 
	^ self new initializeWithArchive: aLogArchive.! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:51'!
addRequest: aRequest withSequenceNumber: aSequenceNumber
	| entry |

	(self containsEntryWithSequenceNumber: aSequenceNumber) ifTrue: [
		entry := self entryWithSequenceNumber: aSequenceNumber.
		self archive: entry. ].
	
	entry := ControllerLogEntry newWithRequest: aRequest andSequenceNumber: aSequenceNumber.
	
	entries at: aSequenceNumber put: entry.
! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:21'!
addResponse: aResponse withSequenceNumber: aSequenceNumber
	| logEntry |

	logEntry := entries at: aSequenceNumber.

	logEntry setResponse: aResponse.
	! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 23:12'!
archive
	^ archive! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 23:12'!
archive: anEntry
	archive add: anEntry.! !

!ControllerLog methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:51'!
containsEntryWithSequenceNumber: aNumber 
	[entries at: aNumber] on: KeyNotFound do: [ ^ false ].
	^ true.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:15'!
entryWithSequenceNumber: aSequenceNumber 
	^ entries at: aSequenceNumber.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 23:12'!
initialize
	entries := Dictionary new.
	archive := LinkedList new.! !

Object subclass: #ControllerLogEntry
	instanceVariableNames: 'sequenceNumber request time response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

ControllerLogEntry class
	instanceVariableNames: 'time sequenceNumber request'!

ControllerLogEntry class
	instanceVariableNames: 'time sequenceNumber request'!

!ControllerLogEntry class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:46'!
newWithRequest: aRequest andSequenceNumber: aSequenceNumber
	^ self new initializeWithRequest: aRequest andSequenceNumber: aSequenceNumber.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:34'!
initializeWithRequest: aRequest andSequenceNumber: aSequenceNumber
	time := DateAndTime now.
	request := aRequest.
	sequenceNumber := aSequenceNumber.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:42'!
request
	^ request
! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:20'!
response
	^ response! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:21'!
setResponse: aResponse
	response := aResponse.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:35'!
time
	^ time! !

Object subclass: #MacGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

MacGenerator subclass: #MD5MacGenerator
	instanceVariableNames: 'sequenceNumber serializedCommandCall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MD5MacGenerator class methodsFor: 'key' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
key

	"
	'Generate a random binary key' asByteArray adding 16r00 up to 32 len
	"
	
	^ #[71 101 110 101 114 97 116 101 32 97 32 114 97 110 100 111 109 32 98 105 110 97 114 121 32 107 101 121 00 00 00 00]! !

!MD5MacGenerator methodsFor: 'initialization' stamp: 'HernanWilkinson 3/25/2013 14:54'!
initializeFor: aSerializedCommandCall with: aSequenceNumber

	serializedCommandCall := aSerializedCommandCall.
	sequenceNumber := aSequenceNumber.
! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'HernanWilkinson 3/25/2013 15:36'!
macFrom: md5

	| mac |
	
	mac := md5 first: 3.
	mac swap: 1 with: 3.
	^ mac! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'NahuelGarbezza 5/18/2013 09:40'!
md5For: aStream

	aStream reset.
	^ MD5 hashStream: aStream! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
streamToCalculateMD5

	| stream |
	stream := ReadWriteStream on: ByteArray new.
	stream
		nextPutAll: self key;
		nextPut: (sequenceNumber bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 2) bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 3) bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 4) bitAnd: 16rFF);
		nextPutAll: serializedCommandCall.
	^ stream! !

!MD5MacGenerator methodsFor: 'evaluating' stamp: 'HernanWilkinson 3/25/2013 15:21'!
value

	| stream md5 mac |
	
	stream := self streamToCalculateMD5.
	md5 := self md5For: stream.
	mac := self macFrom: md5.
	
	^ mac
	! !

!MacGenerator class methodsFor: 'instance creation' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
for: aSerializedCommandCall with: aSequenceNumber

	^ self new initializeFor: aSerializedCommandCall with: aSequenceNumber! !

!MacGenerator class methodsFor: 'key' stamp: 'HernanWilkinson 3/25/2013 14:57'!
key

	self subclassResponsibility ! !

!MacGenerator methodsFor: 'initialization' stamp: 'HernanWilkinson 3/25/2013 14:53'!
initializeFor: aSerializedCommandCall with: aSequenceNumber 

	self subclassResponsibility ! !

!MacGenerator methodsFor: 'evaluating' stamp: 'NahuelGarbezza 5/18/2013 09:40'!
key

	^ self class key! !

!MacGenerator methodsFor: 'evaluating' stamp: 'HernanWilkinson 3/25/2013 14:53'!
value

	self subclassResponsibility ! !

Object subclass: #Satellite
	instanceVariableNames: 'subsystems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Satellite class methodsFor: 'instance creation' stamp: 'EmilianoMenendez 9/7/2013 16:27'!
newWithSubsystems: theSubsystems 
	^ self new initalizeWithSubsystems: theSubsystems! !

!Satellite methodsFor: 'signaling' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 19:48'!
emitBeacon
	| result outputStream telemetryDataOrderedBySubsystemId |
	
	outputStream := WriteStream on: String new.
	
	outputStream nextPutAll: '{"telemetry":['.
	
	telemetryDataOrderedBySubsystemId := OrderedIdentityDictionary new.
	
	subsystems do: [ :subsystem | telemetryDataOrderedBySubsystemId at: (subsystem id) put: subsystem telemetry].
	
	telemetryDataOrderedBySubsystemId do: [ :telemetry | outputStream nextPutAll: telemetry. outputStream nextPutAll: ',' ].
	
	result := outputStream contents.
	
	result := result truncateTo: ((result size) - 1).
	
	result := result , ']}'.
	
	^ result.
! !

!Satellite methodsFor: 'signaling' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 21:06'!
emitShortBeacon
	| result outputStream telemetryDataOrderedBySubsystemId |
	
	outputStream := WriteStream on: String new.
	
	outputStream nextPutAll: '{"short_telemetry":['.
	
	telemetryDataOrderedBySubsystemId := OrderedIdentityDictionary new.
	
	subsystems do: [ :subsystem | telemetryDataOrderedBySubsystemId at: (subsystem id) put: subsystem shortTelemetry].
	
	telemetryDataOrderedBySubsystemId do: [ :telemetry | outputStream nextPutAll: telemetry. outputStream nextPutAll: ',' ].
	
	result := outputStream contents.
	
	result := result truncateTo: ((result size) - 1).
	
	result := result , ']}'.
	
	^ result.
! !

!Satellite methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:11'!
initalizeWithSubsystems: theSubsystems

	subsystems := theSubsystems.


! !

!Satellite methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 19:59'!
subsystems
	
	^ subsystems
! !

Object subclass: #SatelliteController
	instanceVariableNames: 'radioStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/28/2013 18:00'!
encode: aCommand withSequenceNumber: aSequenceNumber
	| subsystemId encodedCommand encodedBytes stream sequenceNumberByteArray sequenceNumberParameter mac |

	subsystemId := aCommand receiver id.

	encodedCommand := aCommand serialize.

	macGenerator := MD5MacGenerator for: encodedCommand with: aSequenceNumber.
	mac := macGenerator value.
		
	sequenceNumberParameter := UnsignedIntegerCommandParameter new: 24.
	sequenceNumberParameter value: (aSequenceNumber number).
	
	sequenceNumberByteArray := sequenceNumberParameter serialize.
	
	encodedBytes := ByteArray new: (mac asByteArray size) + (sequenceNumberByteArray size) + (subsystemId asByteArray size) + (encodedCommand size).
	
	stream := WriteStream on: encodedBytes.
	
	stream nextPutAll: mac asByteArray.
	stream nextPutAll: sequenceNumberByteArray.
	stream nextPutAll: subsystemId asByteArray.
	stream nextPutAll: encodedCommand.
	
	^ encodedBytes.! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/28/2013 17:00'!
initialize 
	"radioStream := SocketStream openConnectionToHostNamed: 'localhost' port: 4445."
	radioStream := SocketStream openConnectionToHost:  NetNameResolver localHostAddress port: 4445.
	radioStream binary.! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/24/2013 23:11'!
radioStream
	^ radioStream
! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/24/2013 23:10'!
shutdown 
	radioStream close.
! !

Object subclass: #SatelliteSubsystem
	instanceVariableNames: 'id data telemetryKeys shortTelemetryKeys name commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

SatelliteSubsystem subclass: #MemorySatelliteSubsystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemorySatelliteSubsystem class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:00'!
newWithId: theId andName: theName
	| subsystem telemetryKeys shortTelemetryKeys |
	
	telemetryKeys := Set new.
	telemetryKeys add: 'free'.
	
	shortTelemetryKeys := Set new.
	shortTelemetryKeys add: 'free'.
	
	subsystem := self new initializeWithId: theId andName: theName andTelemetryKeys: telemetryKeys andShortTelemetryKeys: shortTelemetryKeys.
	
	^ subsystem.! !

SatelliteSubsystem subclass: #PlatformSatelliteSubsystem
	instanceVariableNames: 'matrixKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PlatformSatelliteSubsystem class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 17:30'!
newWithId: theId andName: theName
	| subsystem telemetryKeys shortTelemetryKeys platformSetModeCommand platformSetModeCommandEntry |
	
	telemetryKeys := Set new.
	telemetryKeys add: 'tick_count'.
	telemetryKeys add: 'current_mode'.
	
	shortTelemetryKeys := Set new.
	
	platformSetModeCommand := PlatformSetModeCommand new.
	platformSetModeCommandEntry := Association key: 'setMode' value: platformSetModeCommand.
	
	subsystem := self new initializeWithId: theId andName: theName andTelemetryKeys: telemetryKeys andShortTelemetryKeys: shortTelemetryKeys andCommands: platformSetModeCommandEntry.
	
	^ subsystem.! !

!PlatformSatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 17:31'!
setMode: theValue
	data at: 'current_mode' put: theValue! !

SatelliteSubsystem subclass: #PowerSatelliteSubsystem
	instanceVariableNames: 'matrixKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PowerSatelliteSubsystem class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 17:49'!
newWithId: theId andName: theName
	| subsystem telemetryKeys shortTelemetryKeys powerStbSetSwitchesStateCommand powerStbSetSwitchesStateCommandEntry |
	
	telemetryKeys := Set new.
	telemetryKeys add: 'low_voltage_counter'.
	telemetryKeys add: 'battery_v'.
	telemetryKeys add: 'array_X_v'.
	telemetryKeys add: 'array_Xp_mA'.
	telemetryKeys add: 'array_Xm_mA'.
	telemetryKeys add: 'array_Y_v'.
	telemetryKeys add: 'array_Yp_mA'.
	telemetryKeys add: 'array_Y_mA'.
	telemetryKeys add: 'array_Z_v'.
	telemetryKeys add: 'array_Zp_mA'.
	telemetryKeys add: 'array_Zm_mA'.
	telemetryKeys add: '_3v3_mA'.
	telemetryKeys add: '_5v_mA'.

	shortTelemetryKeys := Set new.
	
	powerStbSetSwitchesStateCommand := PowerStbSetSwitchesStateCommand new.
	powerStbSetSwitchesStateCommandEntry := Association key: 'stbSetSwitchesState' value: powerStbSetSwitchesStateCommand.
	
	subsystem := self new initializeWithId: theId andName: theName andTelemetryKeys: telemetryKeys andShortTelemetryKeys: shortTelemetryKeys andCommands: powerStbSetSwitchesStateCommandEntry.
	
	^ subsystem.! !

!PowerSatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 17:42'!
setMode: theValue
	data at: 'current_mode' put: theValue! !

!SatelliteSubsystem class methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 17:21'!
basicCommands
	| commands |
	
	commands := Set new.

	commands add: GetNameCommand.
	commands add: ThermalTelemetryCommand.
	commands add: ThermalShortTelemetryCommand.

	^ commands! !

!SatelliteSubsystem class methodsFor: 'creation' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 18:58'!
newWithId: theId andName: theName
	^ self new initializeWithId: theId andName: theName andTelemetryKeys: Set new andShortTelemetryKeys: Set new! !

!SatelliteSubsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:35'!
= anObject
	^ id = anObject id! !

!SatelliteSubsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 18:27'!
commands
	^ commands! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:03'!
getValueOfAttribute: aKey
	^ (data at: aKey)! !

!SatelliteSubsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:10'!
id
	^ id! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 20:26'!
initializeWithId: theId andName: theName andTelemetryKeys: theTelemetryKeys andShortTelemetryKeys: theShortTelemetryKeys
	id := theId.
	name := theName.
	commands := SatelliteSubsystem basicCommands.
	telemetryKeys := theTelemetryKeys.
	shortTelemetryKeys := theShortTelemetryKeys.
	data := Dictionary new.! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/10/2013 19:37'!
initializeWithId: theId andName: theName andTelemetryKeys: theTelemetryKeys andShortTelemetryKeys: theShortTelemetryKeys andCommands: theCommands
	id := theId.
	name := theName.
	commands := SatelliteSubsystem basicCommands.
	commands add: theCommands.
	telemetryKeys := theTelemetryKeys.
	shortTelemetryKeys := theShortTelemetryKeys.
	data := Dictionary new.! !

!SatelliteSubsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:11'!
name
	^ name! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 12:46'!
setAttribute: aKey withValue: aValue 
	data at: aKey put: aValue! !

!SatelliteSubsystem methodsFor: 'command' stamp: 'EmilianoMenendez 9/9/2013 10:26'!
shortTelemetry
	| result temp |
	
	temp := WriteStream on: String new.
	
	temp nextPutAll: '{'.
	
	"add subsytem_id"
	temp nextPutAll: '"subsystem_id":"'.
	temp nextPutAll: id asString.
	temp nextPutAll: '",'.
	
	"build key:value,key:value,,, string "
	data associationsDo: [ :entry | (shortTelemetryKeys includes: (entry key)) ifTrue: [temp nextPutAll: '"'. temp nextPutAll: (entry key asString) . temp nextPutAll: '":"'. temp nextPutAll: (entry value asString). temp nextPutAll: '",'.]].
	
	"send stream to string"
	result := temp contents.
	
	"remove last ,"
	result := result truncateTo: ((result size) - 1).
	
	result := result , '}'.
	
	^ result
! !

!SatelliteSubsystem methodsFor: 'command' stamp: 'EmilianoMenendez 9/8/2013 20:40'!
telemetry
	| result temp |
	
	temp := WriteStream on: String new.
	
	temp nextPutAll: '{'.
	
	"add subsytem_id"
	temp nextPutAll: '"subsystem_id":"'.
	temp nextPutAll: id asString.
	temp nextPutAll: '",'.
	
	"build key:value,key:value,,, string "
	data associationsDo: [ :entry | temp nextPutAll: '"'. temp nextPutAll: (entry key asString) . temp nextPutAll: '":"'. temp nextPutAll: (entry value asString). temp nextPutAll: '",'.].
	
	"send stream to string"
	result := temp contents.
	
	"remove last ,"
	result := result truncateTo: ((result size) - 1).
	
	result := result , '}'.
	
	^ result
! !

!SatelliteSubsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:22'!
understands: aCommandClass
	^ (commands includes: aCommandClass).! !

SatelliteSubsystem subclass: #ThermalSatelliteSubsystem
	instanceVariableNames: 'matrixKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ThermalSatelliteSubsystem class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 17:20'!
newWithId: theId andName: theName
	| subsystem telemetryKeys shortTelemetryKeys matrixKeyCommand matrixKeyCommandEntry |
	
	telemetryKeys := Set new.
	telemetryKeys add: 'battery_temp'.
	telemetryKeys add: 'radio_temp'.
	
	shortTelemetryKeys := Set new.
	shortTelemetryKeys add: 'battery_temp'.
	
	matrixKeyCommand := ThermalSetMatrixKeyCommand new.
	matrixKeyCommandEntry := Association key: 'setMatrixKey' value: matrixKeyCommand.
	
	subsystem := self new initializeWithId: theId andName: theName andTelemetryKeys: telemetryKeys andShortTelemetryKeys: shortTelemetryKeys andCommands: matrixKeyCommandEntry.
	
	^ subsystem.! !

!ThermalSatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:07'!
setMatrixKey: theValue
	data at: 'matrix_key' put: theValue! !

Object subclass: #SequenceNumber
	instanceVariableNames: 'number lastNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

SequenceNumber class
	instanceVariableNames: 'number'!

SequenceNumber class
	instanceVariableNames: 'number'!

!SequenceNumber class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/20/2013 17:36'!
startingFrom: aNumber
	^ self new initializeWithStart: aNumber! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 19:08'!
asByteArray
	| resultSize resultBytes sequenceNumber start |

	resultSize := 3.

	resultBytes := ByteArray new: resultSize.
	
	sequenceNumber := number asByteArray.

	start := (resultSize - (sequenceNumber size) + 1).

	^ resultBytes replaceFrom: start to: resultSize with: sequenceNumber. 
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/27/2013 12:55'!
bitAnd: aSmallInteger 
	^number bitAnd: aSmallInteger ! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/27/2013 12:56'!
digitAt: aSmallInteger 
	^number bitAnd: aSmallInteger ! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 21:14'!
initialize
	number := 1.
	lastNumber := LargePositiveInteger readFrom: 'FFFFEF' base: 16.
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:58'!
initializeWithStart: aNumber
	self initialize.
	number := aNumber.! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:53'!
next
	number := number + 1.
	number > lastNumber ifTrue: [ self reset. ].
	^ number.
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 15:00'!
number
	^ number! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:52'!
reset
	number := 1.! !
